assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")

local dreadsteedicon = "Interface\\Icons\\Ability_Mount_Dreadsteed"
local felsteedicon = "Interface\\Icons\\Spell_Nature_Swiftness"
local hasdreadsteed = nil

-- Felsteed
-- Dreadsteed
-- Flying Mount
-- Random Flying / Walking?
-- Leftclick fly, rightclick walk?

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconMount = Necronomicon:NewModule("Mount")
NecronomiconMount.name = "Mount"

NecronomiconMount.revision = tonumber(string.sub("$Revision: 27266 $", 12, -3))

NecronomiconMount.defaults = {
	posx = 264,
	posy = 200,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconMount:OnRegister()
	self:RegisterSpell("Summon Felsteed")
	self:RegisterSpell("Summon Dreadsteed")
end

function NecronomiconMount:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconMount:Necronomicon_SpellsUpdated()
	local dreadsteed = self:HasSpell("Summon Dreadsteed")
	local felsteed = self:HasSpell("Summon Felsteed")

	if dreadsteed then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( dreadsteed.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetTexture( dreadsteedicon )
		self.button:Show()
	elseif felsteed then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( felsteed.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetTexture( felsteedicon )
		self.button:Show()		
	else
		self.button:SetAttribute("type1", "")
		self.button:SetAttribute("spell1", "" )
		self.button:Hide()		
	end
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconMount:SetupButton()
	self:CreateButton()
end
