assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")
local BS = AceLibrary("Babble-Spell-2.2")
local soulstonetarget = nil
local soulstoneid = {
	[5232] = true,
	[16892] = true,
	[16893] = true,
	[16895] = true,
	[16896] = true,
	[22116] = true,
}
local soulstoneicon = "Interface\\Icons\\INV_Misc_Orb_04"
local lastid = 0

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconSoulstone = Necronomicon:NewModule("Soulstone")
NecronomiconSoulstone.name = "Soulstone"

NecronomiconSoulstone.revision = tonumber(string.sub("$Revision: 27266 $", 12, -3))

NecronomiconSoulstone.defaults = {
	posx = 200,
	posy = 232,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconSoulstone:OnRegister()
	self:RegisterSpell("Create Soulstone")
	for k, v in pairs( soulstoneid ) do
		self:RegisterItem( k )
	end
end

function NecronomiconSoulstone:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_BagUpdate")
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED", "UNIT_SPELLCAST_FAILED")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconSoulstone:Necronomicon_SpellsUpdated()
	local spell = self:HasSpell("Create Soulstone")
	if spell then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( spell.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetDesaturated(true)
		self.button:Show()
		self:Necronomicon_BagUpdate()
	else
		self.button:SetAttribute("type1", "")
		self.button:SetAttribute("spell1", "" )
		self.button:SetAttribute("item1", "")
		self.button:Hide()
	end
end

function NecronomiconSoulstone:Necronomicon_BagUpdate()
	local item, name
	for k, v in pairs( soulstoneid ) do
		item = self:GetItem(k)
		if item then
			name = (GetItemInfo(GetContainerItemLink( item.bag, item.slot )))
			self.button:SetAttribute("type1", "item")
			self.button:SetAttribute("item1", name)
			self.button.background:SetDesaturated(false)
			break
		end
	end
	if not item then
		self.button.background:SetDesaturated(true)
		self.button:SetAttribute("type1", "spell")
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_SENT(unit, spell, rank, target)
	if unit == "player" and spell == BS["Soulstone Resurrection"] then
		soulstonetarget = UnitName(target)
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_START(unit)
	if unit == "player" and soulstonetarget then
		self:Message( L["Soulstoning %s!"]:format(soulstonetarget) )
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_SUCCEEDED(unit, spell, rank)
	if unit == "player" and soulstonetarget then 
		self:Message( L["Soulstone placed on %s!"]:format(soulstonetarget) )
		soulstonetarget = nil
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_FAILED(unit)
	if unit == "player" and soulstonetarget then
		self:Message( L["Soulstone Aborted!"] )
		soulstonetarget = nil
	end
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconSoulstone:SetupButton()
	self:CreateButton()

	self.button.background:SetTexture( soulstoneicon )
end