assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")
local spellstoneid = {
	[5522] = true,
	[13602] = true,
	[13603] = true,
	[22646] = true,
}
local spellstoneicon = "Interface\\Icons\\INV_Misc_Gem_Sapphire_01"

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconSpellstone = Necronomicon:NewModule("Spellstone")
NecronomiconSpellstone.name = "Spellstone"

NecronomiconSpellstone.revision = tonumber(string.sub("$Revision: 26866 $", 12, -3))

NecronomiconSpellstone.defaults = {
	posx = 264,
	posy = 232,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconSpellstone:OnRegister()
	self:RegisterSpell("Create Spellstone")
	for k, v in pairs( spellstoneid ) do
		self:RegisterItem( k )
	end
end

function NecronomiconSpellstone:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_BagUpdate")
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconSpellstone:Necronomicon_SpellsUpdated()
	local spell = self:HasSpell("Create Spellstone")
	if spell then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( spell.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetDesaturated(true)
		self.button.highlight:Hide()
		self.button:Show()

		self:Necronomicon_BagUpdate()
	else
		self.button:SetAttribute("type1", "")
		self.button:SetAttribute("spell1", "" )
		self.button:Hide()	
	end
end

function NecronomiconSpellstone:Necronomicon_BagUpdate()
	local item, name
	for k, v in pairs( spellstoneid ) do
		item = self:GetItem(k)
		if item then
			self.button:SetAttribute("type1", "item")
			self.button.background:SetDesaturated(false)
			if item.equipped then
				name = (GetItemInfo(GetInventoryItemLink("player",GetInventorySlotInfo("RangedSlot"))))
				self.button:SetAttribute("item1", name)
				self.button:SetAttribute("slot1", (GetInventorySlotInfo("RangedSlot")))
				self.button:SetAttribute("bag1", "")
				self.button.highlight:Show()
			else
				name = (GetItemInfo(GetContainerItemLink( item.bag, item.slot )))
				self.button:SetAttribute("item1", name)
				self.button:SetAttribute("bag1", item.bag)
				self.button:SetAttribute("slot1", item.slot)
				self.button.highlight:Hide()
			end
			break
		end
	end
	if not item then
		self.button.background:SetDesaturated(true)
		self.button:SetAttribute("type1", "spell")
		self.button.highlight:Hide()
	end

end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconSpellstone:SetupButton()
	self:CreateButton()

	self.button.background:SetTexture( spellstoneicon )
end
